#! /usr/bin/env python3
from anotador import Anotador
import sys
class Menu:
    '''Mostrar un menú y responder a las opciones'''
    def __init__(self):
        self.anotador = Anotador()
        self.opciones= {
            "1": self.mostrar_notas,
            "2": self.buscar_notas,
            "3": self.agregar_nota,
            "4": self.modificar_nota,
            "5": self.salir
        }

    def mostrar_menu(self):
        print("""
Menú del anotador:
1. Mostrar todas las notas
2. Buscar Notas
3. Agregar Nota
4. Modificar Nota
5. Salir
""")

    def ejecutar(self):
        '''Mostrar el menu y responder a las opciones.'''
        while True:
            self.mostrar_menu()
            opcion = input("Ingresar una opción: ")
            accion = self.opciones.get(opcion)
            if accion:
                accion()
            else:
                print("{0} no es una opción válida".format(opcion))

    def mostrar_notas(self, notas=None):
        '''Si recibe como parámetro una lista de notas, muestra id, texto y
        etiquetas de esas notas. Si no recibe el parámetro, muestra id, texto
        y etiquetas de todas las notas'''
        #TODO: Construir este método, borrar el siguiente renglón:
        print("El método mostrar_notas aún no está construido")
    
    def buscar_notas(self):
        filtro = input("Buscar: ")
        notas = self.anotador.buscar(filtro)
        if notas:
            self.mostrar_notas(notas)
        else:
            print("Ninguna nota coincide con la búsqueda")
    
    def agregar_nota(self):
        '''Solicita un texto al usuario y agrega una nueva nota con ese texto'''
        #TODO: Construir este método, borrar el siguiente renglón:
        print("El método agregar_notas aún no está construido")

    def modificar_nota(self):
        id = input("Ingrese el id de la nota a modificar: ")
        texto = input("Ingrese el texto de la nota: ")
        etiquetas = input("Ingrese las etiquetas: ")
        if texto:
            self.anotador.modificar_nota(id, texto)
        if etiquetas:
            self.anotador.modificar_etiquetas(id, etiquetas)
    
    def salir(self):
        print("Gracias por utilizar el sistema.")
        sys.exit(0)

#Esta parte del código está fuera de la clase Menu.
#Si este archivo es el programa principal (es decir, si no ha sido importado
#desde otro módulo, sino ejecutado directamente), entonces llamamos al método
# ejecutar(). 
if __name__ == "__main__":
    Menu().ejecutar()
